import { Reducible, Action, Dispatch } from 'pretur.redux';
import { PageInstance } from './pageInstance';
import { Pages, PageInstantiationData } from './pages';
export declare function deisolate<A extends Action<any, any>>(action: A): A;
export interface PageReplaceOptions extends PageInstantiationData<any> {
    toRemoveMutex: string;
}
export interface PageOpenOptions extends PageInstantiationData<any> {
    insertAfterMutex?: string;
}
export declare class Navigator implements Reducible {
    private _pages;
    private _prefix;
    private _instances;
    private _activePageMutex;
    constructor(pages: Pages, prefix?: string);
    readonly all: PageInstance<any, any, any>[];
    readonly roots: PageInstance<any, any, any>[];
    readonly active: PageInstance<any, any, any> | undefined;
    readonly activeMutex: string | undefined;
    readonly activeRootMutex: string | undefined;
    readonly activeRootIndex: number;
    readonly indexAsChildOfActiveRoot: number;
    hasChildren(mutex: string): boolean;
    childrenOf(mutex: string): PageInstance<any, any, any>[];
    pageFromMutex(mutex: string | undefined): PageInstance<any, any, any> | undefined;
    private persistInstances(instances);
    private persistActivePage(instances, mutex);
    reduce(action: Action<any, any>): this;
    transit(dispatch: Dispatch, mutex: string | undefined): void;
    open(dispatch: Dispatch, instantiationData: PageOpenOptions): void;
    replace(dispatch: Dispatch, toRemoveMutex: string, instantiationData: PageInstantiationData<any>): void;
    close(dispatch: Dispatch, mutex: string): void;
    load(dispatch: Dispatch): void;
    clear(dispatch: Dispatch): void;
}
